Package org.zkoss.stateless.sul

## Interface IRow<I extends IAnyGroup>

- All Superinterfaces:
    `IChildable<IRow<I>,​I>`, `IComponent<IRow<I>>`, `IComposite<IRow<I>,​IComponent>`, `IHtmlBasedComponent<IRow<I>>`, `IRowBase<IRow<I>>`, `IXulElement<IRow<I>>`

      public interface IRow<I extends IAnyGroup>
      extends IRowBase<IRow<I>>, IChildable<IRow<I>,​I>, IComposite<IRow<I>,​IComponent>

  Immutable `Row` component

  A single row in a `IRows` element. Each child of the `IRow` component is placed in each successive cell of the grid. The row with the most child components determines the number of columns in each row.

  Author:
    katherine
  See Also:
    `Row`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `IRow.Builder<I extends IAnyGroup>` | Builds instances of type `IRow`.
    `static class` | `IRow.Updater` | Builds an updater of type `IRow` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static IRow<IAnyGroup>` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `IDetailChild<? extends IDetailChild>` | `getDetailChild()` | Returns the child detail component.
    `default java.lang.String` | `getHflex()` | Return horizontal flex hint of this component.
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `default java.lang.String` | `getWidth()` | Returns the width of the component.
    `static <I extends IAnyGroup> IRow<I>` | `of​(I... children)` | Returns the instance with the given any group children.
    `static <I extends IAnyGroup> IRow<I>` | `of​(java.lang.Iterable<? extends I> children)` | Returns the instance with the given any group children.
    `static <I extends IAnyGroup> IRow<I>` | `ofId​(java.lang.String id)` | Returns the instance with the given id.
    `default IRow<I>` | `withAllComponents​(java.lang.Iterable<? extends IComponent> elements)` | Copy the current immutable object with elements that replace the content of `children`.
    `IRow<I>` | `withDetailChild​(IDetailChild<? extends IDetailChild> detailChild)` | Returns a copy of `this` immutable component with the specified `detailChild` class name.
    `default IRow` | `withHflex​(java.lang.String hflex)` | To control the size of Foot related components, please refer to `IGrid` and `IColumn` instead.
    `default IRow` | `withWidth​(java.lang.String width)` | To control the size of Foot related components, please refer to `IGrid` and `IColumn` instead.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IChildable

      `getChildren, withChildren, withChildren`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IRowBase

      `getAlign, getIndex, getValign, isLoaded, isNowrap, withAlign, withIndex, withNowrap, withValign`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final IRow<IAnyGroup> DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zul.grid.Row"`

      Specified by:
        `getWidgetClass` in interface `IComponent<I extends IAnyGroup>`

    - #### getWidth

          @Derived
          @Nullable
          default java.lang.String getWidth()

      Description copied from interface: `IHtmlBasedComponent`
      Returns the width of the component. If not specified, `null` is assumed.

      Default: `null`

      Specified by:
        `getWidth` in interface `IHtmlBasedComponent<I extends IAnyGroup>`

    - #### withWidth

          default IRow withWidth​(@Nullable
                                 java.lang.String width)

      To control the size of Foot related components, please refer to `IGrid` and `IColumn` instead.
      Specified by:
        `withWidth` in interface `IHtmlBasedComponent<I extends IAnyGroup>`
      Parameters:
        `width` - The width of the component.

        Default: `null`

      Returns:
        A modified copy of the `this` object

    - #### getHflex

          @Derived
          @Nullable
          default java.lang.String getHflex()

      Description copied from interface: `IHtmlBasedComponent`
      Return horizontal flex hint of this component.

      Default: `null`

      Specified by:
        `getHflex` in interface `IHtmlBasedComponent<I extends IAnyGroup>`

    - #### withHflex

          default IRow withHflex​(@Nullable
                                 java.lang.String hflex)

      To control the size of Foot related components, please refer to `IGrid` and `IColumn` instead.
      Specified by:
        `withHflex` in interface `IHtmlBasedComponent<I extends IAnyGroup>`
      Parameters:
        `hflex` - The horizontal flex hint.

        Default: `null`

      Returns:
        A modified copy of the `this` object

    - #### getDetailChild

          @Nullable
          IDetailChild<? extends IDetailChild> getDetailChild()

      Returns the child detail component.

    - #### withDetailChild

          IRow<I> withDetailChild​(@Nullable
                                  IDetailChild<? extends IDetailChild> detailChild)

      Returns a copy of `this` immutable component with the specified `detailChild` class name.

      Sets the detail child (EE only)

      Parameters:
        `detailChild` - The detail child

        Default: `null`.

      Returns:
        A modified copy of the `this` object

    - #### withAllComponents

          default IRow<I> withAllComponents​(java.lang.Iterable<? extends IComponent> elements)

      Description copied from interface: `IComposite`
      Copy the current immutable object with elements that replace the content of `children`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Specified by:
        `withAllComponents` in interface `IComposite<IRow<I extends IAnyGroup>,​IComponent>`
      Parameters:
        `elements` - An iterable of children elements to set
      Returns:
        A modified copy of `this` object

    - #### of

          static <I extends IAnyGroup> IRow<I> of​(java.lang.Iterable<? extends I> children)

      Returns the instance with the given any group children.
      Parameters:
        `children` - The children belong to any group
      See Also:
        `IAnyGroup`

    - #### of

          static <I extends IAnyGroup> IRow<I> of​(I... children)

      Returns the instance with the given any group children.
      Parameters:
        `children` - The children belong to any group
      See Also:
        `IAnyGroup`

    - #### ofId

          static <I extends IAnyGroup> IRow<I> ofId​(java.lang.String id)

      Returns the instance with the given id.
      Parameters:
        `id` - The id to identify this component